#lang racket/gui

;;; ----------------------------------------------------------------;;;
;;;                     A-IDE v0.2 source code                      ;;;
;;; Author: Antoine Bossard (Kanagawa University, Japan)            ;;;
;;; Licence: MIT licence                                            ;;;
;;; Homepage: https://www.sci.kanagawa-u.ac.jp/info/abossard/a-ide/ ;;;
;;;                    Copyright (c) A. Bossard                     ;;;
;;; ----------------------------------------------------------------;;;

; --- exports ---
(provide twostate-message%)

; --- body ---
(define twostate-message%
  (class message%
    (init state)
    (define label-when-set "*")
    (define label-when-unset "")
    (super-new [label (if state label-when-set label-when-unset)])

    (define message-state state)
    
    (define (is-unset?)
      (not message-state))

    (define (set)
      (set! message-state #t)
      (send this set-label label-when-set))

    (define (unset)
      (set! message-state #f)
      (send this set-label label-when-unset))
    (public unset)
    
    (define (set-when-unset)
      (when (is-unset?) (set)))
    (public set-when-unset)
    
    ))
